"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = __importDefault(require("util"));
/**
 * A wrapper around a callback-based IBlockService that allows async/await
 * There is an open PR on the bitswap PR which will allow us to switch to the ipfs-maintained version.
 * @public
 */
class WrappedBlockService {
    constructor(blockservice) {
        this.blockservice = blockservice;
    }
    put(block) {
        return util_1.default.promisify(this.blockservice.put.bind(this.blockservice))(block);
    }
    get(cid) {
        return util_1.default.promisify(this.blockservice.get.bind(this.blockservice))(cid);
    }
    delete(cid) {
        return util_1.default.promisify(this.blockservice.delete.bind(this.blockservice))(cid);
    }
    setExchange(bitswap) {
        this.blockservice.setExchange(bitswap);
    }
    unsetExchange() {
        this.blockservice.unsetExchange();
    }
    hasExchange() {
        return this.blockservice.hasExchange();
    }
}
exports.WrappedBlockService = WrappedBlockService;
